function [sys,x0] = ship_anim(t,x,u,flag,ts)
%ANIMTANK Animation of water tank system.

%   Ned Gulley, 10-4-94
%   Copyright 1994-2002 The MathWorks, Inc. 
%   $Revision: 1.8.2.1 $  $Date: 2003/01/07 19:34:32 $

global shipcontrol

if flag==2,
	if any(get(0,'Children')==shipcontrol),
		if strcmp(get(shipcontrol,'Name'),'Ship control'),

			% Update
			hlist = get(shipcontrol,'UserData');

			shipXdata = [-12 8 8 -12; 8 13 13 8]';
			shipYdata = [-4 -4 4 4; -4 0 0 4]';

			psi = u(3);

			rot1 = [cos(psi) -sin(psi); sin(psi) cos(psi)]*[shipXdata(:,1) shipYdata(:,1)]';
			rot2 = [cos(psi) -sin(psi); sin(psi) cos(psi)]*[shipXdata(:,2) shipYdata(:,2)]';

			xnew = [rot1(1,:); rot2(1,:)]' + mod(u(1),200);
			ynew = [rot1(2,:); rot2(2,:)]' + u(2);

			set(hlist(2),'XData',xnew);
			set(hlist(2),'YData',ynew);

			if (any(any(ynew>20 | ynew<-20)))
				set(hlist(2),'facecolor',[rand rand rand]);
			end

			%shipXdata = get(hlist(2),'XData');
			%shipXdata = shipXdata + u(1);
			%shipXdata = [0 20 20 0; 20 25 25 20]' + mod(u(1)+200,200);
			%shipYdata = [0 0 8 8; 0 4 4 8]'-4 + u(2);
			%shipYdata = get(hlist(2),'YData');
			%shipYdata = shipYdata + u(2);


			drawnow;
		end
	end
	sys=[];
	x0=[];
    
elseif flag == 4 % Return next sample hit
  
 %  ns stores the number of samples
%  ns = t/ts;

  % This is the time of the next sample hit.
 % sys = (1 + floor(ns + 1e-13*(1+ns)))*ts;
  x0=[];
  
elseif flag==0,

    % Initialize the figure for use with this simulation
    ship_anim_init('Ship control');
    shipcontrol = findobj(0,'Name','Ship control');

	shipXdata = [-12 8 8 -12; 8 13 13 8]';
	shipYdata = [-4 -4 4 4; -4 0 0 4]';
	
    % Draw the water
    lane_h = patch([-12 213 213 -12]', [-50 -50 50 50],[0 1 1],'EraseMode','normal','EdgeColor','none');

	% Draw banks
	patch([0 200 200 0; 0 200 200 0]',[20 20 22 22; -22 -22 -20 -20]',[0 0 0.5]);
	% Draw banks
	line([0 200],[0 0],'color','black','linestyle','--');

    % Draw the ship
    ship_h = patch(shipXdata,shipYdata,[1 0 0],'erasemode','normal');
    % Draw the anti-water (to erase the blue as we go along)
%    waterY([1 2 5])=tank1Ht*[1 1 1]+1;
 %   waterY([3 4])=tank1Init*[1 1]+1; 
  %  tank2Hndl=patch(waterX,waterY,[.9 .9 .9],'EdgeColor','none','EraseMode','none');
    % Draw the set point
   % lineHndl=line([0 0.4],setPt*[1 1]+1,'Color','red','LineWidth',4, ...
    %'EraseMode','background');


    set(gcf, ...
    'Color',[.9 .9 .9], ...
    'UserData',[lane_h ship_h]);
    set(gca, ...
    'XLim',[-12 213],'YLim',[-30 30], ...
    'XTick',[],'YTick',[], ...
    'XColor','black','YColor','black', ...
    'Box','on');
    axis equal
    %xlabel('Water Level Control','Color','black');
    set(get(gca,'XLabel'),'Visible','on')

    sys=[0 0 0 3 0 0];
    x0=[];

end;
